/*
**
**
**	Demo for the TI TIGA DDK.
**
** Rotating and resizing cube.
**
** This program was written for use with TURBO C++
** 
** Found an old Demo from 1990 and modified it to use TIGA
**	21.11.2016 -  Axel Muhr - 26 yrs later ;)
*/


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include <math.h>

#include <typedefs.h>
#include <tiga.h>
#include <extend.h>

typedef	struct
{
	int	x,y,z;
} D_ARRAY;

D_ARRAY	*dataptr;
D_ARRAY	datas[] =
{
	{1,1,-1},
   {1,1,1},
   {-1,1,1},
   {-1,1,-1},
   {1,1,-1},
   {1,-1,-1},
   {-1,-1,-1},
   {-1,-1,1},
   {-1,1,1},
   {1,1,1},
   {1,-1,1},
   {-1,-1,1},
   {-1,-1,-1},
   {-1,1,-1},
   {1,1,-1},
   {1,-1,-1},
   {1,-1,1},
};


int	far *intptr;
int	far *newptr;
int	far *tmpptr;

void	convert(D_ARRAY *);
void term_tiga();


CONFIG config;

#define	S1		300
#define	S2		150

double	rho,theta, theta_dif,phi,d;
double	s1,c1,s2,c2,cx,cy;

int		sx,sy,sx1,sy1;
int   size;

short oldmode; /* Storage for old videomode */

void term_tiga()
{
	printf("Press any key to return to DOS...");
	getch();
	set_videomode(oldmode,INIT); /* Return mode to prev state */
	tiga_set(CD_CLOSE); /* Close the TIGA CD */
	exit(0); /* Exit back to DOS */
}

void init_tiga(load_graphics_lib)
short load_graphics_lib;
{
short v;
long lv;
/*--------------------------------------------------------------------------- *
/
/* Open TIGA Communications Driver */
/*--------------------------------------------------------------------------- */
if((lv = tiga_set(CD_OPEN)) < 0L)
{
printf("TIGA CD error: %ld\n", lv);
exit(1); /* Exit back to DOS */
}

/*--------------------------------------------------------------------------- */
/* Go into TIGA mode */
/*--------------------------------------------------------------------------- */

oldmode = get_videomode(); /* Save current videomode for later */
if(!(v = set_videomode(TIGA,INIT | CLR_SCREEN)))
{
	printf("TIGA GM error: %d\n", v);
	tiga_set(CD_CLOSE); /* Be sure to close the open TIGA CD */
	exit(1); 						/* before exiting to DOS */
}
/*--------------------------------------------------------------------------- */
/* Load graphics library functions if specified to do so */
/*--------------------------------------------------------------------------- */
if(load_graphics_lib && (v=install_primitives()) < 0)
{
	printf( "Graphics Library load error: %d\n", v );
	term_tiga();
}
}

void  main()
{
   int   ip_result;
   char  outbuf[80];
   int   i, j;


   if((intptr = farmalloc(32768l)) == NULL)
   {
   	printf("Not enough memory!\n");
      exit(-1);
   }

	/*
	**
	** First, set the video mode.
	**


	if (!(set_videomode(TIGA, INIT_GLOBALS | CLR_SCREEN) ))
   {
      printf("Error: set_videomode() has failed.\n");
      exit(-1);
   }
	*/

init_tiga(1);

	/*
	**
	** Next, install the extended primitives.
	**
	** See page 3-11 of the TIGA-340 User's Guide and 4-82 for
	** an explanation of the error result codes.
	**
	*/

   if (!function_implemented(DRAW_LINE))
   {
      if ( (ip_result = install_primitives()) < 0)
      {
         set_videomode(PREVIOUS, INIT);
         printf("Error: install_primitives() has failed\n");
         printf("with an error code of %d.\n",ip_result);
         exit(-1);
      }
   }


   get_config(&config);



   init_text();
   set_ppop(0);

   set_fcolor(WHITE);

   set_bcolor(BLUE);

   /* cx = (config.mode.disp_hres / 2);
   cy = (config.mode.disp_vres / 2); */
	cx = config.mode.disp_hres >> 1; /* Width 1/2 screen width */
	cy = config.mode.disp_vres >> 1; /* Height 1/2 screen height */

   sprintf(outbuf,"Current Display Mode: %d of %d",config.current_mode,
      config.num_modes);
   text_out(0,0,outbuf);

   sprintf(outbuf,"Resolution: %d by %d by %d bits",config.mode.disp_hres,
      config.mode.disp_vres, config.mode.disp_psize);
   text_out(0,20,outbuf);

   sprintf(outbuf, "Number of pages: %d",config.mode.num_pages);
   text_out(0,40,outbuf);

   sprintf(outbuf, "Pallet size: %ld",config.mode.palet_size);
   text_out(0,60,outbuf);

   getch();

   clear_screen(BLACK);

   set_fcolor(15);

   /* 10 */
   rho = 10.0;
   theta = 0.0;
   theta_dif = 0.1;
   phi = 1.3;
   d = 500;

   /* 20 */
   s2 = sin(phi);
   c2 = cos(phi);

   newptr = intptr;
   for(d = 0; d < 2000; d+=20)
   {
	   s1 = sin(theta);
	   c1 = cos(theta);
      theta += theta_dif;
      if(theta == 1.8)
      	theta_dif = -0.1;
      if(theta == 0.0)
      	theta_dif = 0.1;

		dataptr = datas;
      for(i = 0; i < 17; i++)
      {
	      convert(dataptr++);
         *newptr++ = sx;
         *newptr++ = sy;
      }
   }

   for(d = 2000; d > 0; d-=20)
   {
	   s1 = sin(theta);
	   c1 = cos(theta);
      theta += theta_dif;
      if(theta == 1.8)
      	theta_dif = -0.1;
      if(theta == 0.0)
      	theta_dif = 0.1;

		dataptr = datas;
      for(i = 0; i < 17; i++)
      {
	      convert(dataptr++);
         *newptr++ = sx;
         *newptr++ = sy;
      }
   }

   while(kbhit()) getch();	/* Clear the key buffer */


   while(1)
   {

   	if(kbhit())	break;

      newptr = intptr;
      for(d = 0; d < 200; d++)
      {
	   	if(kbhit())	break;

   	   set_fcolor(15);
         tmpptr = newptr;
         wait_scan(0);

		   i = 0;
         sx1 = -1;
         while(i++ < 17)
         {
         	sx = *newptr++;
            sy = *newptr++;

            if(sx1 != -1)
	            draw_line(sx1,sy1,sx,sy);

            sx1 = sx;
		      sy1 = sy;
         }

	   	if(kbhit())	break;

   	   set_fcolor(0);
         newptr = tmpptr;
         wait_scan(0);

		   i = 0;
         sx1 = -1;
         while(i++ < 17)
         {
         	sx = *newptr++;
            sy = *newptr++;

            if(sx1 != -1)
	            draw_line(sx1,sy1,sx,sy);

            sx1 = sx;
		      sy1 = sy;
         }
      }
	}

	getch();

     term_tiga(); /* Properly terminate TIGA */

exit(0); /* sane Exit back to DOS */
}


void	convert(D_ARRAY *data)
{
	double xe,ye,ze;

   xe = -data->x * s1 + data->y * c1;
   ye = -data->x * c1 * c2 - data->y * s1 * c2 + data->z * s2;
	ze = -data->x * s2 * c1 - data->y * s2 * s1 - data->z * c2 + rho;

   sx = (int)(d * xe / ze + cx);
   sy = (int)(cy - d * ye / ze);
}